package hu.bme.mit.socialnetwork.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import hu.bme.mit.socialnetwork.services.SocialNetworkLanguageGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialNetworkLanguageParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'socialnetwork'", "'{'", "'}'", "'aquaintance'", "'is'", "'community'", "','", "'person'", "'memberships'", "'M'", "'F'", "'friend of'", "'collegue of'"
    };
    public static final int RULE_ID=4;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalSocialNetworkLanguageParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSocialNetworkLanguageParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSocialNetworkLanguageParser.tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g"; }



     	private SocialNetworkLanguageGrammarAccess grammarAccess;
     	
        public InternalSocialNetworkLanguageParser(TokenStream input, SocialNetworkLanguageGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "SocialNetwork";	
       	}
       	
       	@Override
       	protected SocialNetworkLanguageGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:68:1: entryRuleSocialNetwork returns [EObject current=null] : iv_ruleSocialNetwork= ruleSocialNetwork EOF ;
    public final EObject entryRuleSocialNetwork() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialNetwork = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:69:2: (iv_ruleSocialNetwork= ruleSocialNetwork EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:70:2: iv_ruleSocialNetwork= ruleSocialNetwork EOF
            {
             newCompositeNode(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75);
            iv_ruleSocialNetwork=ruleSocialNetwork();

            state._fsp--;

             current =iv_ruleSocialNetwork; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSocialNetwork"


    // $ANTLR start "ruleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:77:1: ruleSocialNetwork returns [EObject current=null] : (otherlv_0= 'socialnetwork' otherlv_1= '{' ( (lv_entities_2_0= ruleSocialEntity ) )+ ( (lv_acquaintances_3_0= ruleAcquaintance ) )* otherlv_4= '}' ) ;
    public final EObject ruleSocialNetwork() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_4=null;
        EObject lv_entities_2_0 = null;

        EObject lv_acquaintances_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:80:28: ( (otherlv_0= 'socialnetwork' otherlv_1= '{' ( (lv_entities_2_0= ruleSocialEntity ) )+ ( (lv_acquaintances_3_0= ruleAcquaintance ) )* otherlv_4= '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'socialnetwork' otherlv_1= '{' ( (lv_entities_2_0= ruleSocialEntity ) )+ ( (lv_acquaintances_3_0= ruleAcquaintance ) )* otherlv_4= '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'socialnetwork' otherlv_1= '{' ( (lv_entities_2_0= ruleSocialEntity ) )+ ( (lv_acquaintances_3_0= ruleAcquaintance ) )* otherlv_4= '}' )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:3: otherlv_0= 'socialnetwork' otherlv_1= '{' ( (lv_entities_2_0= ruleSocialEntity ) )+ ( (lv_acquaintances_3_0= ruleAcquaintance ) )* otherlv_4= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleSocialNetwork122); 

                	newLeafNode(otherlv_0, grammarAccess.getSocialNetworkAccess().getSocialnetworkKeyword_0());
                
            otherlv_1=(Token)match(input,12,FOLLOW_12_in_ruleSocialNetwork134); 

                	newLeafNode(otherlv_1, grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:89:1: ( (lv_entities_2_0= ruleSocialEntity ) )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==16||LA1_0==18) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:90:1: (lv_entities_2_0= ruleSocialEntity )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:90:1: (lv_entities_2_0= ruleSocialEntity )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:91:3: lv_entities_2_0= ruleSocialEntity
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSocialNetworkAccess().getEntitiesSocialEntityParserRuleCall_2_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleSocialEntity_in_ruleSocialNetwork155);
            	    lv_entities_2_0=ruleSocialEntity();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSocialNetworkRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"entities",
            	            		lv_entities_2_0, 
            	            		"SocialEntity");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:107:3: ( (lv_acquaintances_3_0= ruleAcquaintance ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==14) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:108:1: (lv_acquaintances_3_0= ruleAcquaintance )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:108:1: (lv_acquaintances_3_0= ruleAcquaintance )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:109:3: lv_acquaintances_3_0= ruleAcquaintance
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSocialNetworkAccess().getAcquaintancesAcquaintanceParserRuleCall_3_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleAcquaintance_in_ruleSocialNetwork177);
            	    lv_acquaintances_3_0=ruleAcquaintance();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSocialNetworkRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"acquaintances",
            	            		lv_acquaintances_3_0, 
            	            		"Acquaintance");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            otherlv_4=(Token)match(input,13,FOLLOW_13_in_ruleSocialNetwork190); 

                	newLeafNode(otherlv_4, grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_4());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSocialNetwork"


    // $ANTLR start "entryRuleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:137:1: entryRuleAcquaintance returns [EObject current=null] : iv_ruleAcquaintance= ruleAcquaintance EOF ;
    public final EObject entryRuleAcquaintance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAcquaintance = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:138:2: (iv_ruleAcquaintance= ruleAcquaintance EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:139:2: iv_ruleAcquaintance= ruleAcquaintance EOF
            {
             newCompositeNode(grammarAccess.getAcquaintanceRule()); 
            pushFollow(FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance226);
            iv_ruleAcquaintance=ruleAcquaintance();

            state._fsp--;

             current =iv_ruleAcquaintance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAcquaintance236); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAcquaintance"


    // $ANTLR start "ruleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:146:1: ruleAcquaintance returns [EObject current=null] : (otherlv_0= 'aquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) ( (otherlv_4= RULE_ID ) ) ) ;
    public final EObject ruleAcquaintance() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Enumerator lv_type_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:149:28: ( (otherlv_0= 'aquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) ( (otherlv_4= RULE_ID ) ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:150:1: (otherlv_0= 'aquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) ( (otherlv_4= RULE_ID ) ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:150:1: (otherlv_0= 'aquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) ( (otherlv_4= RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:150:3: otherlv_0= 'aquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) ( (otherlv_4= RULE_ID ) )
            {
            otherlv_0=(Token)match(input,14,FOLLOW_14_in_ruleAcquaintance273); 

                	newLeafNode(otherlv_0, grammarAccess.getAcquaintanceAccess().getAquaintanceKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:154:1: ( (otherlv_1= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:155:1: (otherlv_1= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:155:1: (otherlv_1= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:156:3: otherlv_1= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getAcquaintanceRule());
            	        }
                    
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAcquaintance293); 

            		newLeafNode(otherlv_1, grammarAccess.getAcquaintanceAccess().getSourcePersonCrossReference_1_0()); 
            	

            }


            }

            otherlv_2=(Token)match(input,15,FOLLOW_15_in_ruleAcquaintance305); 

                	newLeafNode(otherlv_2, grammarAccess.getAcquaintanceAccess().getIsKeyword_2());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:171:1: ( (lv_type_3_0= ruleAcquaintanceType ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:172:1: (lv_type_3_0= ruleAcquaintanceType )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:172:1: (lv_type_3_0= ruleAcquaintanceType )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:173:3: lv_type_3_0= ruleAcquaintanceType
            {
             
            	        newCompositeNode(grammarAccess.getAcquaintanceAccess().getTypeAcquaintanceTypeEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleAcquaintanceType_in_ruleAcquaintance326);
            lv_type_3_0=ruleAcquaintanceType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAcquaintanceRule());
            	        }
                   		set(
                   			current, 
                   			"type",
                    		lv_type_3_0, 
                    		"AcquaintanceType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:189:2: ( (otherlv_4= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:190:1: (otherlv_4= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:190:1: (otherlv_4= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:191:3: otherlv_4= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getAcquaintanceRule());
            	        }
                    
            otherlv_4=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAcquaintance346); 

            		newLeafNode(otherlv_4, grammarAccess.getAcquaintanceAccess().getTargetPersonCrossReference_4_0()); 
            	

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcquaintance"


    // $ANTLR start "entryRuleSocialEntity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:210:1: entryRuleSocialEntity returns [EObject current=null] : iv_ruleSocialEntity= ruleSocialEntity EOF ;
    public final EObject entryRuleSocialEntity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialEntity = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:211:2: (iv_ruleSocialEntity= ruleSocialEntity EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:212:2: iv_ruleSocialEntity= ruleSocialEntity EOF
            {
             newCompositeNode(grammarAccess.getSocialEntityRule()); 
            pushFollow(FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity382);
            iv_ruleSocialEntity=ruleSocialEntity();

            state._fsp--;

             current =iv_ruleSocialEntity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialEntity392); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSocialEntity"


    // $ANTLR start "ruleSocialEntity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:219:1: ruleSocialEntity returns [EObject current=null] : (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) ;
    public final EObject ruleSocialEntity() throws RecognitionException {
        EObject current = null;

        EObject this_Person_0 = null;

        EObject this_Community_1 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:222:28: ( (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:223:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:223:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==18) ) {
                alt3=1;
            }
            else if ( (LA3_0==16) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:224:5: this_Person_0= rulePerson
                    {
                     
                            newCompositeNode(grammarAccess.getSocialEntityAccess().getPersonParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_rulePerson_in_ruleSocialEntity439);
                    this_Person_0=rulePerson();

                    state._fsp--;

                     
                            current = this_Person_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:234:5: this_Community_1= ruleCommunity
                    {
                     
                            newCompositeNode(grammarAccess.getSocialEntityAccess().getCommunityParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleCommunity_in_ruleSocialEntity466);
                    this_Community_1=ruleCommunity();

                    state._fsp--;

                     
                            current = this_Community_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSocialEntity"


    // $ANTLR start "entryRuleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:250:1: entryRuleCommunity returns [EObject current=null] : iv_ruleCommunity= ruleCommunity EOF ;
    public final EObject entryRuleCommunity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCommunity = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:251:2: (iv_ruleCommunity= ruleCommunity EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:252:2: iv_ruleCommunity= ruleCommunity EOF
            {
             newCompositeNode(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity501);
            iv_ruleCommunity=ruleCommunity();

            state._fsp--;

             current =iv_ruleCommunity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity511); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleCommunity"


    // $ANTLR start "ruleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:259:1: ruleCommunity returns [EObject current=null] : (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )? ) ;
    public final EObject ruleCommunity() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_children_3_0 = null;

        EObject lv_children_5_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:262:28: ( (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )? ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:263:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )? )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:263:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )? )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:263:3: otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )?
            {
            otherlv_0=(Token)match(input,16,FOLLOW_16_in_ruleCommunity548); 

                	newLeafNode(otherlv_0, grammarAccess.getCommunityAccess().getCommunityKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:267:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:268:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:268:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:269:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleCommunity565); 

            			newLeafNode(lv_name_1_0, grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getCommunityRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:285:2: (otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}' )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==12) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:285:4: otherlv_2= '{' ( (lv_children_3_0= ruleCommunity ) ) (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )* otherlv_6= '}'
                    {
                    otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleCommunity583); 

                        	newLeafNode(otherlv_2, grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0());
                        
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:289:1: ( (lv_children_3_0= ruleCommunity ) )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:290:1: (lv_children_3_0= ruleCommunity )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:290:1: (lv_children_3_0= ruleCommunity )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:291:3: lv_children_3_0= ruleCommunity
                    {
                     
                    	        newCompositeNode(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_1_0()); 
                    	    
                    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity604);
                    lv_children_3_0=ruleCommunity();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getCommunityRule());
                    	        }
                           		add(
                           			current, 
                           			"children",
                            		lv_children_3_0, 
                            		"Community");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:307:2: (otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) ) )*
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==17) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:307:4: otherlv_4= ',' ( (lv_children_5_0= ruleCommunity ) )
                    	    {
                    	    otherlv_4=(Token)match(input,17,FOLLOW_17_in_ruleCommunity617); 

                    	        	newLeafNode(otherlv_4, grammarAccess.getCommunityAccess().getCommaKeyword_2_2_0());
                    	        
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:311:1: ( (lv_children_5_0= ruleCommunity ) )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:312:1: (lv_children_5_0= ruleCommunity )
                    	    {
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:312:1: (lv_children_5_0= ruleCommunity )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:313:3: lv_children_5_0= ruleCommunity
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_2_1_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity638);
                    	    lv_children_5_0=ruleCommunity();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getCommunityRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"children",
                    	            		lv_children_5_0, 
                    	            		"Community");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop4;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,13,FOLLOW_13_in_ruleCommunity652); 

                        	newLeafNode(otherlv_6, grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_3());
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCommunity"


    // $ANTLR start "entryRulePerson"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:341:1: entryRulePerson returns [EObject current=null] : iv_rulePerson= rulePerson EOF ;
    public final EObject entryRulePerson() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerson = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:342:2: (iv_rulePerson= rulePerson EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:343:2: iv_rulePerson= rulePerson EOF
            {
             newCompositeNode(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson690);
            iv_rulePerson=rulePerson();

            state._fsp--;

             current =iv_rulePerson; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson700); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePerson"


    // $ANTLR start "rulePerson"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:350:1: rulePerson returns [EObject current=null] : (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ) ;
    public final EObject rulePerson() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Enumerator lv_sex_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:353:28: ( (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:354:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:354:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:354:3: otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}'
            {
            otherlv_0=(Token)match(input,18,FOLLOW_18_in_rulePerson737); 

                	newLeafNode(otherlv_0, grammarAccess.getPersonAccess().getPersonKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:358:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:359:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:359:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:360:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson754); 

            			newLeafNode(lv_name_1_0, grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPersonRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_rulePerson771); 

                	newLeafNode(otherlv_2, grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:380:1: ( (lv_sex_3_0= ruleSex ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:381:1: (lv_sex_3_0= ruleSex )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:381:1: (lv_sex_3_0= ruleSex )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:382:3: lv_sex_3_0= ruleSex
            {
             
            	        newCompositeNode(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleSex_in_rulePerson792);
            lv_sex_3_0=ruleSex();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getPersonRule());
            	        }
                   		set(
                   			current, 
                   			"sex",
                    		lv_sex_3_0, 
                    		"Sex");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:398:2: (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==19) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:398:4: otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    {
                    otherlv_4=(Token)match(input,19,FOLLOW_19_in_rulePerson805); 

                        	newLeafNode(otherlv_4, grammarAccess.getPersonAccess().getMembershipsKeyword_4_0());
                        
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:402:1: ( (otherlv_5= RULE_ID ) )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:403:1: (otherlv_5= RULE_ID )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:403:1: (otherlv_5= RULE_ID )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:404:3: otherlv_5= RULE_ID
                    {

                    			if (current==null) {
                    	            current = createModelElement(grammarAccess.getPersonRule());
                    	        }
                            
                    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson825); 

                    		newLeafNode(otherlv_5, grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_1_0()); 
                    	

                    }


                    }

                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:415:2: (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    loop6:
                    do {
                        int alt6=2;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0==17) ) {
                            alt6=1;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:415:4: otherlv_6= ',' ( (otherlv_7= RULE_ID ) )
                    	    {
                    	    otherlv_6=(Token)match(input,17,FOLLOW_17_in_rulePerson838); 

                    	        	newLeafNode(otherlv_6, grammarAccess.getPersonAccess().getCommaKeyword_4_2_0());
                    	        
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:419:1: ( (otherlv_7= RULE_ID ) )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:420:1: (otherlv_7= RULE_ID )
                    	    {
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:420:1: (otherlv_7= RULE_ID )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:421:3: otherlv_7= RULE_ID
                    	    {

                    	    			if (current==null) {
                    	    	            current = createModelElement(grammarAccess.getPersonRule());
                    	    	        }
                    	            
                    	    otherlv_7=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson858); 

                    	    		newLeafNode(otherlv_7, grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_2_1_0()); 
                    	    	

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_8=(Token)match(input,13,FOLLOW_13_in_rulePerson874); 

                	newLeafNode(otherlv_8, grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePerson"


    // $ANTLR start "ruleSex"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:444:1: ruleSex returns [Enumerator current=null] : ( (enumLiteral_0= 'M' ) | (enumLiteral_1= 'F' ) ) ;
    public final Enumerator ruleSex() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:446:28: ( ( (enumLiteral_0= 'M' ) | (enumLiteral_1= 'F' ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:447:1: ( (enumLiteral_0= 'M' ) | (enumLiteral_1= 'F' ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:447:1: ( (enumLiteral_0= 'M' ) | (enumLiteral_1= 'F' ) )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==20) ) {
                alt8=1;
            }
            else if ( (LA8_0==21) ) {
                alt8=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:447:2: (enumLiteral_0= 'M' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:447:2: (enumLiteral_0= 'M' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:447:4: enumLiteral_0= 'M'
                    {
                    enumLiteral_0=(Token)match(input,20,FOLLOW_20_in_ruleSex924); 

                            current = grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:453:6: (enumLiteral_1= 'F' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:453:6: (enumLiteral_1= 'F' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:453:8: enumLiteral_1= 'F'
                    {
                    enumLiteral_1=(Token)match(input,21,FOLLOW_21_in_ruleSex941); 

                            current = grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSex"


    // $ANTLR start "ruleAcquaintanceType"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:463:1: ruleAcquaintanceType returns [Enumerator current=null] : ( (enumLiteral_0= 'friend of' ) | (enumLiteral_1= 'collegue of' ) ) ;
    public final Enumerator ruleAcquaintanceType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:465:28: ( ( (enumLiteral_0= 'friend of' ) | (enumLiteral_1= 'collegue of' ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:466:1: ( (enumLiteral_0= 'friend of' ) | (enumLiteral_1= 'collegue of' ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:466:1: ( (enumLiteral_0= 'friend of' ) | (enumLiteral_1= 'collegue of' ) )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==22) ) {
                alt9=1;
            }
            else if ( (LA9_0==23) ) {
                alt9=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:466:2: (enumLiteral_0= 'friend of' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:466:2: (enumLiteral_0= 'friend of' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:466:4: enumLiteral_0= 'friend of'
                    {
                    enumLiteral_0=(Token)match(input,22,FOLLOW_22_in_ruleAcquaintanceType986); 

                            current = grammarAccess.getAcquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getAcquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:472:6: (enumLiteral_1= 'collegue of' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:472:6: (enumLiteral_1= 'collegue of' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/socialnetwork/parser/antlr/internal/InternalSocialNetworkLanguage.g:472:8: enumLiteral_1= 'collegue of'
                    {
                    enumLiteral_1=(Token)match(input,23,FOLLOW_23_in_ruleAcquaintanceType1003); 

                            current = grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcquaintanceType"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleSocialNetwork122 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleSocialNetwork134 = new BitSet(new long[]{0x0000000000050000L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_ruleSocialNetwork155 = new BitSet(new long[]{0x0000000000056000L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_ruleSocialNetwork177 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_13_in_ruleSocialNetwork190 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance226 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAcquaintance236 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_ruleAcquaintance273 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAcquaintance293 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_15_in_ruleAcquaintance305 = new BitSet(new long[]{0x0000000000C00000L});
    public static final BitSet FOLLOW_ruleAcquaintanceType_in_ruleAcquaintance326 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAcquaintance346 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity382 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialEntity392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_ruleSocialEntity439 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleSocialEntity466 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity501 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity511 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_ruleCommunity548 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleCommunity565 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_12_in_ruleCommunity583 = new BitSet(new long[]{0x0000000000050000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity604 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_17_in_ruleCommunity617 = new BitSet(new long[]{0x0000000000050000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity638 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_13_in_ruleCommunity652 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson690 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson700 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_rulePerson737 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson754 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_rulePerson771 = new BitSet(new long[]{0x0000000000300000L});
    public static final BitSet FOLLOW_ruleSex_in_rulePerson792 = new BitSet(new long[]{0x0000000000082000L});
    public static final BitSet FOLLOW_19_in_rulePerson805 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson825 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_17_in_rulePerson838 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson858 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_13_in_rulePerson874 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_ruleSex924 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ruleSex941 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_ruleAcquaintanceType986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_23_in_ruleAcquaintanceType1003 = new BitSet(new long[]{0x0000000000000002L});

}