package hu.bme.mit.socialnetwork.validation;

import hu.bme.mit.socialnetwork.socialNetworkLanguage.Acquaintance;
import hu.bme.mit.socialnetwork.socialNetworkLanguage.Person;
import hu.bme.mit.socialnetwork.socialNetworkLanguage.SocialNetworkLanguagePackage;

import org.eclipse.xtext.validation.Check;

public class SocialNetworkLanguageJavaValidator extends
		AbstractSocialNetworkLanguageJavaValidator {

	// @Check
	// public void checkGreetingStartsWithCapital(Greeting greeting) {
	// if (!Character.isUpperCase(greeting.getName().charAt(0))) {
	// warning("Name should start with a capital",
	// MyDslPackage.Literals.GREETING__NAME);
	// }
	// }

	@Check
	public void checkAcquaintanceEnds(Acquaintance acq) {
		Person src = acq.getSource();
		Person trg = acq.getTarget();
		if (src.equals(trg)) {
			error("Acquaintance should be defined between two different persons.",
					SocialNetworkLanguagePackage.Literals.ACQUAINTANCE__SOURCE);
			error("Acquaintance should be defined between two different persons.",
					SocialNetworkLanguagePackage.Literals.ACQUAINTANCE__TARGET);
		}
	}
}
